<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>kgraphinterface.kdevelop: kgraphinterface/src/node.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.7 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="annotated.html"><span>Classes</span></a></li>
    <li id="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
  </ul></div>
<div class="nav">
<a class="el" href="dir_13bf8767770a07be1dadcd74264f09a2.html">kgraphinterface</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_cd0dc5b52ac10de8cdc9686ef8f66f03.html">src</a></div>
<h1>node.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/***************************************************************************</span>
<a name="l00002"></a>00002 <span class="comment"> *   Copyright (C) 2007 by Schpilka Yannick   *</span>
<a name="l00003"></a>00003 <span class="comment"> *   schpilka@gmail.com   *</span>
<a name="l00004"></a>00004 <span class="comment"> *                                                                         *</span>
<a name="l00005"></a>00005 <span class="comment"> *   This program is free software; you can redistribute it and/or modify  *</span>
<a name="l00006"></a>00006 <span class="comment"> *   it under the terms of the GNU General Public License as published by  *</span>
<a name="l00007"></a>00007 <span class="comment"> *   the Free Software Foundation; either version 2 of the License, or     *</span>
<a name="l00008"></a>00008 <span class="comment"> *   (at your option) any later version.                                   *</span>
<a name="l00009"></a>00009 <span class="comment"> *                                                                         *</span>
<a name="l00010"></a>00010 <span class="comment"> *   This program is distributed in the hope that it will be useful,       *</span>
<a name="l00011"></a>00011 <span class="comment"> *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *</span>
<a name="l00012"></a>00012 <span class="comment"> *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *</span>
<a name="l00013"></a>00013 <span class="comment"> *   GNU General Public License for more details.                          *</span>
<a name="l00014"></a>00014 <span class="comment"> *                                                                         *</span>
<a name="l00015"></a>00015 <span class="comment"> *   You should have received a copy of the GNU General Public License     *</span>
<a name="l00016"></a>00016 <span class="comment"> *   along with this program; if not, write to the                         *</span>
<a name="l00017"></a>00017 <span class="comment"> *   Free Software Foundation, Inc.,                                       *</span>
<a name="l00018"></a>00018 <span class="comment"> *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *</span>
<a name="l00019"></a>00019 <span class="comment"> *                                                                         *</span>
<a name="l00020"></a>00020 <span class="comment"> *   In addition, as a special exception, the copyright holders give       *</span>
<a name="l00021"></a>00021 <span class="comment"> *   permission to link the code of this program with any edition of       *</span>
<a name="l00022"></a>00022 <span class="comment"> *   the Qt library by Trolltech AS, Norway (or with modified versions     *</span>
<a name="l00023"></a>00023 <span class="comment"> *   of Qt that use the same license as Qt), and distribute linked         *</span>
<a name="l00024"></a>00024 <span class="comment"> *   combinations including the two.  You must obey the GNU General        *</span>
<a name="l00025"></a>00025 <span class="comment"> *   Public License in all respects for all of the code used other than    *</span>
<a name="l00026"></a>00026 <span class="comment"> *   Qt.  If you modify this file, you may extend this exception to        *</span>
<a name="l00027"></a>00027 <span class="comment"> *   your version of the file, but you are not obligated to do so.  If     *</span>
<a name="l00028"></a>00028 <span class="comment"> *   you do not wish to do so, delete this exception statement from        *</span>
<a name="l00029"></a>00029 <span class="comment"> *   your version.                                                         *</span>
<a name="l00030"></a>00030 <span class="comment"> ***************************************************************************/</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifndef NODE_H</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#define NODE_H</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;qwidget.h&gt;</span>
<a name="l00035"></a>00035 
<a name="l00040"></a>00040 <span class="keyword">class </span>Graph;
<a name="l00041"></a>00041 <span class="keyword">class </span>QWidgetStack;
<a name="l00042"></a>00042 <span class="keyword">class </span><a class="code" href="classNodeContent.html">NodeContent</a>;
<a name="l00043"></a>00043 <span class="keyword">class </span>QPopupMenu;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">class </span>Node : <span class="keyword">public</span> QWidget{
<a name="l00046"></a>00046         Q_OBJECT
<a name="l00047"></a>00047         <span class="keyword">public</span>:
<a name="l00048"></a>00048                 Node(Graph *parent,QString <span class="keywordtype">id</span>);
<a name="l00049"></a>00049                 ~Node();
<a name="l00050"></a>00050 
<a name="l00052"></a>00052                 <span class="keywordtype">void</span>    push(<a class="code" href="classNodeContent.html">NodeContent</a> *c);
<a name="l00053"></a>00053 
<a name="l00055"></a>00055                 <span class="keywordtype">void</span>    adjustMenu();
<a name="l00056"></a>00056 
<a name="l00059"></a>00059                 <span class="keywordtype">void</span> setStackColor(QColor c);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061         <span class="keyword">public</span> slots:
<a name="l00063"></a>00063                 <span class="keywordtype">void</span>    addContent(<span class="keywordtype">int</span> i);
<a name="l00064"></a>00064 
<a name="l00066"></a>00066                 <span class="keywordtype">void</span>    pop (QString c);
<a name="l00068"></a>00068                 <span class="keywordtype">void</span>    unpop (QString c);
<a name="l00069"></a>00069                 
<a name="l00070"></a>00070                 <span class="keywordtype">void</span> createEdge();
<a name="l00071"></a>00071                 <span class="keywordtype">void</span> linkTo();
<a name="l00072"></a>00072                 <span class="keywordtype">void</span> popVisibleWidget();
<a name="l00073"></a>00073                 <span class="keywordtype">void</span> popWidget(<span class="keywordtype">int</span>);
<a name="l00074"></a>00074                 <span class="keywordtype">void</span> recoverWidget(<span class="keywordtype">int</span>);
<a name="l00075"></a>00075                 <span class="keywordtype">void</span> switchContent();
<a name="l00076"></a>00076 
<a name="l00077"></a>00077         signals:
<a name="l00078"></a>00078                 <span class="keywordtype">void</span> nodeMoved();
<a name="l00079"></a>00079                 <span class="keywordtype">void</span> createEdge(QString);
<a name="l00080"></a>00080                 <span class="keywordtype">void</span> endEdge(QString);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="keyword">protected</span>:
<a name="l00085"></a>00085                 <span class="keywordtype">void</span>    mousePressEvent(QMouseEvent *event);
<a name="l00086"></a>00086                 <span class="keywordtype">void</span>    mouseReleaseEvent(QMouseEvent *event);
<a name="l00087"></a>00087                 <span class="keywordtype">void</span>    mouseMoveEvent(QMouseEvent *event);
<a name="l00088"></a>00088 
<a name="l00090"></a>00090                 <span class="keywordtype">void</span> dragEnterEvent (QDragEnterEvent *event);
<a name="l00091"></a>00091                 <span class="keywordtype">void</span> dropEvent ( QDropEvent *event );
<a name="l00092"></a>00092 
<a name="l00093"></a>00093                 <span class="keywordtype">void</span> paintEvent (QPaintEvent *event);
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <span class="keyword">private</span>:
<a name="l00098"></a>00098                 <span class="keywordtype">void</span> initMenu();
<a name="l00099"></a>00099 
<a name="l00101"></a>00101                 QWidgetStack *stack;
<a name="l00102"></a>00102 
<a name="l00104"></a>00104                 QMap&lt;QString,NodeContent*&gt; contents;
<a name="l00105"></a>00105 
<a name="l00107"></a>00107                 QMap&lt;int,NodeContent*&gt;::Iterator it;
<a name="l00108"></a>00108 
<a name="l00110"></a>00110                 QPopupMenu *context_menu;
<a name="l00111"></a>00111                 QPopupMenu *raise_menu;
<a name="l00112"></a>00112                 QPopupMenu *extract_menu;
<a name="l00113"></a>00113                 QPopupMenu *repush_menu;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115                 <span class="keywordtype">bool</span> moving;
<a name="l00116"></a>00116                 QPoint move_start;
<a name="l00117"></a>00117 };
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Sun Jun 10 14:17:38 2007 for kgraphinterface.kdevelop by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.7 </small></address>
</body>
</html>
